package com.loafle.overflow.central.module.infra.service;

import java.util.List;

import com.loafle.overflow.central.module.infra.dao.InfraHostIPDAO;
import com.loafle.overflow.central.module.infra.dao.InfraHostPortDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.infra.InfraHostIP;
import com.loafle.overflow.model.infra.InfraHostPort;
import com.loafle.overflow.service.central.infra.InfraHostIPService;
import com.loafle.overflow.service.central.infra.InfraHostPortService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by insanity on 17. 6. 28.
 */

@Service("InfraOSIPService")
public class CentralInfraHostIPService implements InfraHostIPService {
  @Autowired
  InfraHostIPDAO infraHostIPDAO;

  public InfraHostIP regist(InfraHostIP infraHostIP) throws OverflowException {
    return this.infraHostIPDAO.save(infraHostIP);
  }

  public InfraHostIP read(Long id) throws OverflowException {
    return this.infraHostIPDAO.findById(id).get();
  }

  public List<InfraHostIP> readByInfraHostID(Long infraHostID) throws OverflowException {
    return this.infraHostIPDAO.findAllByInfraHostId(infraHostID);
  }

  public List<InfraHostIP> readByInfraHostIDAndMetaIPTypeKey(Long infraHostID, String metaIPTypeKey)
      throws OverflowException {
    return this.infraHostIPDAO.findAllByInfraHostIdAndMetaIPTypeKey(infraHostID, metaIPTypeKey);
  }

  public InfraHostIP readByInfraHostIDAndMetaIPTypeKeyAndAddress(Long infraHostID, String metaIPTypeKey, String address)
      throws OverflowException {
    return this.infraHostIPDAO.findByInfraHostIdAndMetaIPTypeKeyAndAddress(infraHostID, metaIPTypeKey, address);
  }

}
