package com.loafle.overflow.central.module.infra.service;

import com.loafle.overflow.central.module.infra.dao.InfraZoneDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.infra.InfraZone;
import com.loafle.overflow.service.central.infra.InfraZoneService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


@Service("InfraZoneService")
public class CentralInfraZoneService implements InfraZoneService {

  @Autowired
  InfraZoneDAO infraZoneDAO;

  public InfraZone regist(InfraZone infraZone) throws OverflowException {
    return this.infraZoneDAO.save(infraZone);
  }

  public InfraZone read(Long id) throws OverflowException {
    return this.infraZoneDAO.findById(id).get();
  }

  public List<InfraZone> readAllByProbeID(Long probeID) throws OverflowException {
    return this.infraZoneDAO.findAllByProbeId(probeID);
  }

  public List<InfraZone> readAllByDomainID(Long domainID) throws OverflowException {
    return this.infraZoneDAO.findAllByProbeDomainId(domainID);
  }
}
