package com.loafle.overflow.central.module.meta.service;

import com.loafle.overflow.central.module.meta.dao.MetaSensorItemKeyDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.meta.MetaSensorItemKey;
import com.loafle.overflow.service.central.meta.MetaSensorItemKeyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by snoop on 17. 8. 29.
 */

@Service("MetaSensorItemKeyService")
public class CentralMetaSensorItemKeyService implements MetaSensorItemKeyService {

    @Autowired
    private MetaSensorItemKeyDAO metaSensorItemKeyDAO;

    public List<MetaSensorItemKey> readAllByMetaCrawlerID(Short metaCrawlerID) throws OverflowException {
        return this.metaSensorItemKeyDAO.findAllByMetaCrawlerId(metaCrawlerID);
    }

    public Map<Integer, MetaSensorItemKey> readAllMapByMetaCrawlerID(Short metaCrawlerID) throws OverflowException {

        Map<Integer, MetaSensorItemKey> resultMap = new HashMap<>();

        List<MetaSensorItemKey> resultList = this.metaSensorItemKeyDAO.findAllByMetaCrawlerId(metaCrawlerID);

        for (MetaSensorItemKey oa : resultList) {
            resultMap.put(oa.getMetaSensorItem().getId(), oa);
        }

        return resultMap;
    }
}
